import hashlib
import random

from python_sensor_sim.lc_event_generator_helper import LCEventGeneratorHelper
from python_sensor_sim.psc_event_proto_helper import (
    create_ip_address_object,
    create_new_actor,
    create_new_file_object,
    create_new_netconn_object,
)


class Events:
    def __init__(self):
        self.test_events = ""
        self.zip_file_location = ""

    def generate_zip_for_event_creation(self):
        rand_int = random.randint(0, 1000000)
        rand_name = random.choice(
            ['Mario', 'Luigi', 'Wario', 'Peach', 'Bowser', 'Toad', 'Yoshi', 'DonkeyKong', 'DiddyKong'])
        new_file = create_new_file_object(f'c:\\program files (x86)\\schwetap\\secret_file-{rand_int}.txt')
        new_file_2 = create_new_file_object(f'c:\\program files (x86)\\schwetap\\秘密なファイル-{rand_int}.txt')
        new_dll_file = create_new_file_object(f'c:\\$windows.~bt\\sources\\definitely_not_malware-{rand_int}.dll')

        local_ip = create_ip_address_object(2130706433)  # localhost
        remote_ip = create_ip_address_object(3089475776)  # 10.32.0.10 bit9.local proxy
        netcon_obj = create_new_netconn_object(local_ip, random.randint(0, 9999), remote_ip, random.randint(0, 9999))

        parent_random_bits = str(65109968622014886483232272901592313125017846848594184824651604109406300139487).encode(
            'utf-8')
        actor_random_bits = str(95257983443230133259946829811733289809004916790774260241405531490329280988575).encode(
            'utf-8')
        parent_process = create_new_actor('C:\\WINDOWS\\system32\\svchost.exe',
                                          'C:\\WINDOWS\\system32\\svchost.exe -k netsvcs -p',
                                          pid=804,
                                          md5_hash=hashlib.md5(parent_random_bits).hexdigest(),
                                          sha256_hash=hashlib.sha256(parent_random_bits).hexdigest(),
                                          user_id='S-1-5-18',
                                          user_name='NT AUTHORITY\\SYSTEM')

        actor_process = create_new_actor(f'c:\\program files (x86)\\ioa\\IOA.exe',
                                         f'c:\\program files (x86)\\ioa\\IOA.exe '
                                         f'\\qwer sad olasdjf',
                                         pid=805,
                                         parent_pid=parent_process.pid.pid,
                                         md5_hash=hashlib.md5(actor_random_bits).hexdigest(),
                                         sha256_hash=hashlib.sha256(actor_random_bits).hexdigest())

        actor_process_2 = create_new_actor(f'c:\\program files (x86)\\{rand_name}\\秘密なファイル-{rand_int}.exe',
                                           f'c:\\program files (x86)\\{rand_name}\\秘密なファイル-{rand_int}.exe '
                                           '\\qwer 秘密なファイル -olasdjf',
                                           parent_pid=parent_process.pid.pid)

        self.test_events = LCEventGeneratorHelper().add_child_process_event(actor_process, parent_process) \
            .add_regmod_event(f'HKLM\\Software\\WOW6432Node\\{rand_name}\\Update\\', actor_process, parent_process) \
            .add_file_create_write_event(actor_process, new_file) \
            .add_file_create_write_event(actor_process, new_file_2) \
            .add_child_process_event(actor_process_2, parent_process) \
            .add_modload_event(actor_process, new_dll_file) \
            .add_netconn_op(actor_process, netcon_obj)

        self.test_events.flush_current_batch_events_to_file()
        self.zip_file_location = self.test_events.to_zip()
